var request = require('request');

module.exports = function(RED) {
    function NodeRedChatAPIRocketchat(config) {
        RED.nodes.createNode(this,config);
        this.endpoint = config.endpoint;
        this.authtoken = config.authtoken;
        this.userId = config.userId;
        var node = this;

        node.on('input', function(msg) {
          var headers = {
            "X-Auth-Token" : msg.payload.authToken||this.authToken,
            "X-User-Id" : msg.payload.userId||this.userId,
            "Content-Type" : "application/json"
          }
          var data = {
            roomId: msg.originalMessage.chat.id,
            channel: msg.originalMessage.chat.id,
            text: msg.payload.text
          };
          request({
              url: this.endpoint,
              method: "POST",
              headers: headers,
              json: data
          }, function (error, response, body) {
            if(response.statusCode == 200){
              node.status({fill:"green",shape:"dot",text:"message sent"});
            } else {
              node.status({fill:"red",shape:"ring",text:"error"});
            }
          });
        });
    }
    RED.nodes.registerType("node-red-node-chat-api-rocketchat",NodeRedChatAPIRocketchat);
}
